"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateTimeRange = void 0;
var _validation = require("@mui/x-date-pickers/validation");
var _dateUtils = require("../internals/utils/date-utils");
var _valueManagers = require("../internals/utils/valueManagers");
const validateTimeRange = ({
  adapter,
  value,
  timezone,
  props
}) => {
  const [start, end] = value;
  const dateTimeValidations = [(0, _validation.validateTime)({
    adapter,
    value: start,
    timezone,
    props
  }), (0, _validation.validateTime)({
    adapter,
    value: end,
    timezone,
    props
  })];
  if (dateTimeValidations[0] || dateTimeValidations[1]) {
    return dateTimeValidations;
  }

  // for partial input
  if (start === null || end === null) {
    return [null, null];
  }
  if (!(0, _dateUtils.isRangeValid)(adapter.utils, value)) {
    return ['invalidRange', 'invalidRange'];
  }
  return [null, null];
};
exports.validateTimeRange = validateTimeRange;
validateTimeRange.valueManager = _valueManagers.rangeValueManager;